<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <title>Document</title>
</head>
<body>
    <div class="container">
        <h2>Lucky Dice Username</h2>
        <div class="form-group">
            <label for="username">Username</label>
            <input type="text" class="form-control" id="inp-username" placeholder="Enter username" name="username">
        </div>
        <div class="form-group">
            <button type="button" class="btn btn-primary" onclick="onBtnShowVoucherHistoryTableClick()">Show voucher history table</button>
        </div>
        <div id="div-table" class="mt-5">
            <table id="table-voucher-history" class="table table-striped table-bordered table-hover">
                <thead>
                    <tr>
                        <th>Ma giam gia</th>
                        <th>Phan tram giam gia</th>
                    </tr>
                </thead>
                <tbody>

                </tbody>
            </table>
        </div>
    </div>
    <script>
        "use strict";
        //region 1
        const gEND_OF_ROW_COL = -1;
        const gCOL_MA_VOUCHER = 0;
        const gCOL_PHAN_TRAM_GIAM_GIA = -1;
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice";

        //region 2
        //region 3
        //ham xu ly su kien khi nhan nut show voucher history table
        function onBtnShowVoucherHistoryTableClick(){
            var vObjectUser = {
                username:""
            };

            //b1 thu thap du lieu
            readDataInput(vObjectUser);
            //b2 validate du lieu
            var vIsCheck = validateDataInput(vObjectUser);
            if(vIsCheck){
                //b3 goi api
                var vVoucherXmlHttp = new XMLHttpRequest();
                callApiGetVoucherData(vVoucherXmlHttp,vObjectUser);
                //b4 xu ly hien thi
                vVoucherXmlHttp.onreadystatechange = function(){
                    if(this.readyState ==gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK){
                        handleVoucherResponse(vVoucherXmlHttp);
                    }
                }    
            }
        } 
        //region 4
        
        //b1
        function readDataInput(paramObjectUser){
            "use strict";
            var vUserName = document.getElementById("inp-username");
            paramObjectUser.username = vUserName.value.trim();
        }

        //b2
        function validateDataInput(paramObjectUser){
            if(paramObjectUser.username == ""){
                alert("Can nhap username!");
                return false;
            }
            return true;
        }
        //b3
        function callApiGetVoucherData(paramXmlHttp,paramObjectUser){
            "use strict"
            paramXmlHttp.open("GET",gBASE_URL + "/voucher-history?username=" + paramObjectUser.username,true);
            paramXmlHttp.send();   
        }
        //b4 
        function handleVoucherResponse(paramXmlHttp){
            "use strict";
            //chuyen json sang object
            console.log(paramXmlHttp.responseText);
            var vVoucherHistory = JSON.parse(paramXmlHttp.responseText);
            //tim element
            var vVoucherHistoryTable = document.getElementById("table-voucher-history");
            //truy xuat phan tu tbody trong table
            //truy xuat bang tag name, ta se co mang cac tbody trong mang, ta lay pha tu so 0 cua mang nay
            var vVoucherTableBody = document.getElementsByTagName("tbody")[0];
            for(var bI=0; bI<vVoucherHistory.vouchers.length;bI++){
                console.log("ma voucher: " + vVoucherHistory.vouchers[bI].maVoucher);
                console.log("phan tram giam gia: "+ vVoucherHistory.vouchers[bI].phanTramGiamGia);
                //them dong
                var bNewRow = vVoucherTableBody.insertRow(gEND_OF_ROW_COL);
                //them 2 cell ma giam gia va phan tram giam gia
                var bMaGiamGiaCell = bNewRow.insertCell(gCOL_MA_VOUCHER);
                var bPhanTramGiamGiaCell = bNewRow.insertCell(gCOL_PHAN_TRAM_GIAM_GIA);
                //dien du lieu cho 2 cell
                bMaGiamGiaCell.innerHTML = vVoucherHistory.vouchers[bI].maVoucher;
                bPhanTramGiamGiaCell.innerHTML = vVoucherHistory.vouchers[bI].phanTramGiamGia + "%";
            }
            
        }
    </script>
</body>
</html>